diff --git a/src/dispnew.c b/src/dispnew.c
index ccb08ec..60f316d 100644
--- a/src/dispnew.c
+++ b/src/dispnew.c
@@ -56,6 +56,468 @@ along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.  */
 #include "w32.h"
 #endif
 
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+struct mc_RGB ch_foreground = {.red = -1.0, .green = -1.0, .blue = -1.0};
+
+struct mc_RGB fc_foreground = {.red = -1.0, .green = -1.0, .blue = -1.0};
+
+int fc_x = 0;
+
+struct glyph_matrix *cursor_matrix;
+
+struct glyphs_skipped
+{
+  ptrdiff_t allocated;
+  ptrdiff_t used;
+  struct skipped_items
+    {
+      int x;
+      int hpos;
+      bool enabled_p;
+    } *skipped;
+};
+
+struct glyphs_skipped array_glyphs_skipped;
+
+/* Update the display of the text area of row VPOS in window W.
+   Value is true if display has changed. */
+static bool
+mc_update_text_area (struct window *w, struct glyph_row *updated_row, int vpos)
+{
+  bool debug_p = false;
+  struct glyph_row *current_row = MATRIX_ROW (w->current_matrix, vpos);
+  struct glyph_row *desired_row = MATRIX_ROW (w->desired_matrix, vpos);
+  struct redisplay_interface *rif = FRAME_RIF (XFRAME (WINDOW_FRAME (w)));
+  struct frame *f = XFRAME (w->frame);
+  bool changed_p = 0;
+  struct mc_RGB lsl = {.red = -1.0, .green = -1.0, .blue = -1.0};
+  enum mc_flavor glyph_flavor = NO_FLAVOR;
+  enum type_of_cursor cursor_type = NO_CURSOR;
+  int wd = -1;
+  bool active_p = (w == XWINDOW (f->selected_window)
+                   && f == FRAME_DISPLAY_INFO (f)->x_highlight_frame);
+  bool cursor_gc_p = false;
+  struct glyph_matrix *desired_matrix = w->desired_matrix;
+  struct glyph_row *bottom_row = MATRIX_BOTTOM_TEXT_ROW (desired_matrix, w);
+  int bottom_vpos = MATRIX_ROW_VPOS (bottom_row, desired_matrix);
+  if (debug_p
+      && vpos != bottom_vpos)
+    fprintf (stderr, "mc_update_text_area (%s):  vpos (%d) | bottom_vpos (%d)\n",
+                      mc_window (w), vpos, bottom_vpos);
+
+  /* If rows are at different X or Y, or rows have different height,
+     or the current row is marked invalid, write the entire line. */
+  if (!current_row->enabled_p
+      || desired_row->y != current_row->y
+      || desired_row->ascent != current_row->ascent
+      || desired_row->phys_ascent != current_row->phys_ascent
+      || desired_row->phys_height != current_row->phys_height
+      || desired_row->visible_height != current_row->visible_height
+      || current_row->overlapped_p
+      /* This next line is necessary for correctly redrawing
+   mouse-face areas after scrolling and other operations.
+   However, it causes excessive flickering when mouse is moved
+   across the mode line.  Luckily, turning it off for the mode
+   line doesn't seem to hurt anything. -- cyd.
+         But it is still needed for the header line. -- kfs. */
+      || (current_row->mouse_face_p
+    && !(current_row->mode_line_p && vpos > 0))
+      || current_row->x != desired_row->x)
+    {
+      output_cursor_to (w, vpos, 0, desired_row->y, desired_row->x);
+
+  if (debug_p
+      && vpos != bottom_vpos)
+    {
+      fprintf (stderr, "WRITE ENTIRE ROW:\n\
+      char (%d/%s) | start_x: (%d) | start_hpos (%d) | length (%d) | vpos (%d)\n",
+      desired_row->glyphs[TEXT_AREA]->u.ch, mc_char_to_string (desired_row->glyphs[TEXT_AREA]->u.ch),
+      desired_row->x, 0, desired_row->used[TEXT_AREA], vpos);
+    }
+      if (desired_row->used[TEXT_AREA])
+        rif->mc_scribe_glyphs (w, desired_matrix, updated_row, desired_row->glyphs[TEXT_AREA],
+                               TEXT_AREA, desired_row->used[TEXT_AREA], vpos,
+                               bottom_vpos, lsl, glyph_flavor, cursor_type, wd,
+                               active_p, cursor_gc_p);
+
+      /* Clear to end of window. */
+      rif->clear_end_of_line (w, updated_row, TEXT_AREA, -1);
+      changed_p = 1;
+
+      /* This erases the cursor.  We do this here because
+         noticeoverwritten_text_cursor cannot easily check this, which
+         might indicate that the whole functionality of
+         noticeoverwritten_text_cursor would better be implemented here.
+         On the other hand, we need noticeoverwritten_text_cursor as long
+         as mouse highlighting is done asynchronously outside of
+         redisplay. */
+      if (vpos == w->phys_cursor.vpos)
+        w->phys_cursor_on_p = 0;
+
+  /* The entire row was redrawn above, so all fake cursors must be redrawn. */
+  mc_draw_row (w, desired_matrix, updated_row, desired_row->glyphs[TEXT_AREA],
+               desired_row->x, desired_row->used[TEXT_AREA], vpos, bottom_vpos,
+               active_p, cursor_matrix, fc_x, ch_foreground, fc_foreground, true);
+    }
+  else
+    {
+      int stop, i, x;
+      struct glyph *current_glyph = current_row->glyphs[TEXT_AREA];
+      struct glyph *desired_glyph = desired_row->glyphs[TEXT_AREA];
+      bool overlapping_glyphs_p = current_row->contains_overlapping_glyphs_p;
+      int desired_stop_pos = desired_row->used[TEXT_AREA];
+      bool abort_skipping = 0;
+
+      /* If the desired row extends its face to the text area end, and
+   unless the current row also does so at the same position,
+   make sure we write at least one glyph, so that the face
+   extension actually takes place. */
+      if (MATRIX_ROW_EXTENDS_FACE_P (desired_row)
+          && (desired_stop_pos < current_row->used[TEXT_AREA]
+              || (desired_stop_pos == current_row->used[TEXT_AREA]
+                  && !MATRIX_ROW_EXTENDS_FACE_P (current_row))))
+        --desired_stop_pos;
+
+      stop = min (current_row->used[TEXT_AREA], desired_stop_pos);
+      i = 0;
+      x = desired_row->x;
+      int clear_to_x = 0;
+
+      /* Loop over glyphs that current and desired row may have in common. */
+      while (i < stop)
+  {
+
+    array_glyphs_skipped.used = 0;
+
+    bool can_skip_p = !abort_skipping;
+
+    /* Skip over glyphs that both rows have in common.  These
+       don't have to be written.  We can't skip if the last
+       current glyph overlaps the glyph to its right.  For
+       example, consider a current row of `if ' with the `f' in
+       Courier bold so that it overlaps the ` ' to its right.
+       If the desired row is ` ', we would skip over the space
+       after the `if' and there would remain a pixel from the
+       `f' on the screen. */
+    if (overlapping_glyphs_p && i > 0)
+      {
+        struct glyph *glyph = &current_row->glyphs[TEXT_AREA][i - 1];
+        int left, right;
+        rif->get_glyph_overhangs (glyph, XFRAME (w->frame), &left, &right);
+        can_skip_p = (right == 0 && !abort_skipping);
+      }
+
+    if (can_skip_p)
+      {
+        int start_hpos = i;
+
+        while (i < stop
+               && GLYPH_EQUAL_P (desired_glyph, current_glyph))
+          {
+            ++array_glyphs_skipped.used;
+            if (array_glyphs_skipped.allocated < array_glyphs_skipped.used)
+              {
+                int old_alloc = array_glyphs_skipped.allocated;
+                int new_elts = array_glyphs_skipped.used - array_glyphs_skipped.allocated;
+                array_glyphs_skipped.skipped =
+                  xpalloc (array_glyphs_skipped.skipped,
+                           &array_glyphs_skipped.allocated,
+                           new_elts,
+                           INT_MAX,
+                           sizeof *array_glyphs_skipped.skipped);
+                memset (array_glyphs_skipped.skipped + old_alloc, 0,
+                         (array_glyphs_skipped.allocated - old_alloc)
+                           * sizeof *array_glyphs_skipped.skipped);
+              }
+            int nth = array_glyphs_skipped.used - 1;
+            array_glyphs_skipped.skipped[nth].x = x;
+            array_glyphs_skipped.skipped[nth].hpos = i;
+            array_glyphs_skipped.skipped[nth].enabled_p = true;
+            x += desired_glyph->pixel_width;
+            ++desired_glyph, ++current_glyph, ++i;
+          }
+
+        /* Consider the case that the current row contains "xxx
+     ppp ggg" in italic Courier font, and the desired row
+     is "xxx ggg".  The character `p' has lbearing, `g'
+     has not.  The loop above will stop in front of the
+     first `p' in the current row.  If we would start
+     writing glyphs there, we wouldn't erase the lbearing
+     of the `p'.  The rest of the lbearing problem is then
+     taken care of by draw_glyphs. */
+        if (overlapping_glyphs_p
+            && i > 0
+            && i < current_row->used[TEXT_AREA]
+            && (current_row->used[TEXT_AREA] != desired_row->used[TEXT_AREA]))
+          {
+            int left, right;
+            rif->get_glyph_overhangs (current_glyph,
+                    XFRAME (w->frame),
+                    &left, &right);
+            while (left > 0 && i > 0)
+              {
+                --i, --desired_glyph, --current_glyph;
+                x -= desired_glyph->pixel_width;
+                left -= desired_glyph->pixel_width;
+              }
+            /* Abort the skipping algorithm if we end up before
+               our starting point, to avoid looping (bug#1070).
+               This can happen when the lbearing is larger than
+               the pixel width. */
+            abort_skipping = (i < start_hpos);
+          }
+      }
+
+    /* Try to avoid writing the entire rest of the desired row
+       by looking for a resync point.  This mainly prevents
+       mode line flickering in the case the mode line is in
+       fixed-pitch font, which it usually will be. */
+    if (i < desired_row->used[TEXT_AREA])
+      {
+        int start_x = x, start_hpos = i;
+        struct glyph *start = desired_glyph;
+        int current_x = x;
+        bool skip_first_p = !can_skip_p;
+        /* Find the next glyph that's equal again. */
+        while (i < stop
+               && (skip_first_p
+                   || !GLYPH_EQUAL_P (desired_glyph, current_glyph))
+               && x == current_x)
+          {
+            x += desired_glyph->pixel_width;
+            current_x += current_glyph->pixel_width;
+            ++desired_glyph, ++current_glyph, ++i;
+            skip_first_p = 0;
+          }
+
+  for (int elt = 0;
+       elt < array_glyphs_skipped.used
+       && vpos != bottom_vpos;
+       ++elt)
+    {
+      int x = array_glyphs_skipped.skipped[elt].x;
+      int hpos = array_glyphs_skipped.skipped[elt].hpos;
+      struct glyph *target_glyph =
+        mc_get_cursor_glyph (w, desired_matrix, updated_row, hpos, vpos);
+      if (debug_p)
+        fprintf (stderr, "SKIPPED:  char (%d/%s) | x: (%d) | hpos (%d) | vpos (%d)\n",
+                         target_glyph->u.ch, mc_char_to_string (target_glyph->u.ch),
+                         x, hpos, vpos);
+      mc_draw_row (w, desired_matrix, updated_row, target_glyph, x, 1, vpos,
+                   bottom_vpos, active_p, cursor_matrix, fc_x, ch_foreground,
+                   fc_foreground, true);
+    }
+
+        if (i == start_hpos || x != current_x)
+          {
+            i = start_hpos;
+            x = start_x;
+            desired_glyph = start;
+            break;
+          }
+
+        output_cursor_to (w, vpos, start_hpos, desired_row->y, start_x);
+
+  /* Re-draw a portion of the row. */
+
+  if (debug_p
+      && vpos != bottom_vpos)
+    {
+      fprintf (stderr, "REDRAW SEGMENT:\n\
+      char (%d/%s) | start_x: (%d) | start_hpos (%d) | length (%d) | vpos (%d)\n",
+      start->u.ch, mc_char_to_string (start->u.ch),
+      start_x, start_hpos, i - start_hpos, vpos);
+    }
+
+  rif->mc_scribe_glyphs (w, desired_matrix, updated_row, start, TEXT_AREA, i - start_hpos,
+                         vpos, bottom_vpos, lsl,
+                         glyph_flavor, cursor_type, wd, active_p, cursor_gc_p);
+
+  mc_draw_row (w, desired_matrix, updated_row, start, start_x, i - start_hpos,
+               vpos, bottom_vpos, active_p, cursor_matrix, fc_x, ch_foreground,
+               fc_foreground, true);
+
+        changed_p = 1;
+      }
+  }
+
+      /* Write the rest. */
+      if (i < desired_row->used[TEXT_AREA])
+  {
+    output_cursor_to (w, vpos, i, desired_row->y, x);
+
+  if (debug_p
+      && vpos != bottom_vpos)
+    {
+      fprintf (stderr, "DRAW REMAINDER OF THE ROW:\n\
+      char (%d/%s) | x: (%d) | i (%d) | length (%d) | vpos (%d)\n",
+      desired_glyph->u.ch, mc_char_to_string (desired_glyph->u.ch),
+      x, i, desired_row->used[TEXT_AREA] - i, vpos);
+    }
+
+  rif->mc_scribe_glyphs (w, desired_matrix, updated_row, desired_glyph, TEXT_AREA, desired_row->used[TEXT_AREA] - i,
+                         vpos, bottom_vpos, lsl,
+                         glyph_flavor, cursor_type, wd, active_p, cursor_gc_p);
+
+  /* FIXME:  Although we need to update the cache between the end of updated_row
+  and the right window edge, it is not necessary to draw those fake cursors.
+  Although we may not be able to see it with the naked eye, those fake cursors
+  are being superimposed on the existing fake cursors that do not get erased by
+  the code in the section below.  It would be better to only update the cache and
+  suppress double-drawing the fake cursors for the aforementioned area at issue. */
+  mc_draw_row (w, desired_matrix, updated_row, desired_glyph, x,
+               desired_row->used[TEXT_AREA] - i, vpos, bottom_vpos, active_p,
+               cursor_matrix, fc_x, ch_foreground, fc_foreground, true);
+
+    changed_p = 1;
+  }
+
+    /* Everything after the previous change remained the same.  `i` and `x` were
+    incremented to the end of the glyph row.  i == desired_row->used[TEXT_AREA]
+    The `w->output_cursor.x/y/hpos/vpos` is at the end of the previous change.
+    When this situation exists, the distance between the end of the glyph row and
+    the right edge of the window will _not_ be cleared.  Therefore, it is okay to
+    draw the floating glyphs for the horizontal/vertical rulers here. */
+    else if (changed_p)
+      {
+        int x = w->output_cursor.x;
+        int hpos = (w->output_cursor.hpos == updated_row->used[TEXT_AREA])
+                   ? updated_row->used[TEXT_AREA] - 1
+                   : w->output_cursor.hpos;
+        struct glyph *start = mc_get_cursor_glyph (w, desired_matrix, updated_row, hpos, vpos);
+        if (w->output_cursor.x == updated_row->pixel_width)
+          x -= start->pixel_width;
+        if (debug_p)
+          fprintf (stderr, "CHANGED - FROM:  char (%d/%s) | x (%d) | hpos (%d) -- TO END.\n",
+                           start->u.ch, mc_char_to_string (start->u.ch), x, hpos);
+        mc_draw_row (w, desired_matrix, updated_row, start, x,
+                     updated_row->used[TEXT_AREA] - hpos, vpos, bottom_vpos,
+                     active_p, cursor_matrix, fc_x, ch_foreground, fc_foreground,
+                     true);
+      }
+      /* There were no changes and i == desired_row->used[TEXT_AREA] */
+      else if (!changed_p)
+        {
+          if (debug_p)
+            fprintf (stderr, "UNCHANGED -- WRITE ENTIRE LINE.\n");
+          mc_draw_row (w, desired_matrix, updated_row, desired_row->glyphs[TEXT_AREA],
+                       desired_row->x, desired_row->used[TEXT_AREA], vpos,
+                       bottom_vpos, active_p, cursor_matrix, fc_x, ch_foreground,
+                       fc_foreground, true);
+        }
+
+      /* Maybe clear to end of line. */
+      if (MATRIX_ROW_EXTENDS_FACE_P (desired_row))
+        {
+          /* If new row extends to the end of the text area, nothing
+             has to be cleared, if and only if we did a write_glyphs
+             above.  This is made sure by setting desired_stop_pos
+             appropriately above. */
+          eassert (i < desired_row->used[TEXT_AREA]
+                   || ((desired_row->used[TEXT_AREA] == current_row->used[TEXT_AREA])
+                       && MATRIX_ROW_EXTENDS_FACE_P (current_row)));
+        }
+      else if (MATRIX_ROW_EXTENDS_FACE_P (current_row))
+        {
+          /* If old row extends to the end of the text area, clear. */
+          if (i >= desired_row->used[TEXT_AREA])
+            output_cursor_to (w, vpos, i, desired_row->y, desired_row->pixel_width);
+          rif->clear_end_of_line (w, updated_row, TEXT_AREA, -1);
+          clear_to_x = -1;
+          changed_p = 1;
+        }
+      else if (desired_row->pixel_width < current_row->pixel_width)
+        {
+          /* Otherwise clear to the end of the old row.  Everything
+             after that position should be clear already. */
+          int xlim;
+          if (i >= desired_row->used[TEXT_AREA])
+            output_cursor_to (w, vpos, i, desired_row->y, desired_row->pixel_width);
+          /* If cursor is displayed at the end of the line, make sure
+             it's cleared.  Nowadays we don't have a phys_cursor_glyph
+             with which to erase the cursor (because this method
+             doesn't work with lbearing/rbearing), so we must do it this way. */
+          if (vpos == w->phys_cursor.vpos
+              && (desired_row->reversed_p
+                  ? (w->phys_cursor.hpos < 0)
+                  : (w->phys_cursor.hpos >= desired_row->used[TEXT_AREA])))
+            {
+              w->phys_cursor_on_p = 0;
+              xlim = -1;
+            }
+          else
+            xlim = current_row->pixel_width;
+          rif->clear_end_of_line (w, updated_row, TEXT_AREA, xlim);
+          clear_to_x = xlim;
+          changed_p = 1;
+        }
+
+  if (changed_p
+      && clear_to_x != 0)
+    {
+      int text_area_width = window_box_width (w, TEXT_AREA);
+      struct mc_RGB debug_fg = {.red = 0.867, .green = 0.867, .blue = 0.867};
+      struct glyph *target_glyph = updated_row->glyphs[TEXT_AREA] + updated_row->used[TEXT_AREA] - 1;
+      /* `mc_engine' only draws an MC_GLYPH when x < updated_row->pixel_width.
+      The current design inhibits drawing over an existing glyph at the end of a
+      word-wrapped line.  Said glyph receives a fake cursor in either one of the
+      previous sections above, and should not be overwritten with another one.
+      This design is needed because a word-wrapped line does not receive an extra
+      space like non-word-wrapped lines do. */
+      int x = updated_row->pixel_width;
+      int hpos = updated_row->used[TEXT_AREA] - 1;
+      int x_limit = (clear_to_x == -1)
+                    ? text_area_width
+                    : clear_to_x;
+      if (trace_redisplay_p)
+        fprintf (stderr, "mc_update_text_area (floating):  vpos (%d) | x_limit (%d)\n", vpos, x_limit);
+
+      if (BUFFERP (w->contents)
+          && !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+          && !NILP (BVAR (XBUFFER (w->contents), ch_horizontal_ruler))
+          && x < text_area_width
+          && vpos == w->cursor.vpos
+          && target_glyph != NULL)
+        mc_engine (w, desired_matrix, updated_row, target_glyph, TEXT_AREA, x, x_limit,
+                   updated_row->y, hpos, vpos, MC_HBAR, 1, cursor_matrix, fc_x,
+                   debug_p ? debug_fg : ch_foreground, active_p, HORIZONTAL_RULER,
+                   true, NO_CACHE);
+
+      if (BUFFERP (w->contents)
+          && !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+          && !NILP (BVAR (XBUFFER (w->contents), ch_vertical_ruler))
+          && x < text_area_width
+          && vpos != w->cursor.vpos
+          && w->cursor.x >= x
+          && target_glyph != NULL)
+        mc_engine (w, desired_matrix, updated_row, target_glyph, TEXT_AREA, x, x_limit,
+                   updated_row->y, hpos, vpos, MC_BAR, 1, cursor_matrix, fc_x,
+                   debug_p ? debug_fg : ch_foreground, active_p, VERTICAL_RULER,
+                   true, NO_CACHE);
+
+      if (BUFFERP (w->contents)
+          && !NILP (BVAR (XBUFFER (w->contents), fc_visible))
+          && x < text_area_width
+          && fc_x >= x
+          && target_glyph != NULL)
+        mc_engine (w, desired_matrix, updated_row, target_glyph, TEXT_AREA, x, x_limit,
+                   updated_row->y, hpos, vpos, MC_BAR, 1, cursor_matrix, fc_x,
+                   debug_p ? debug_fg : fc_foreground, active_p, FILL_COLUMN,
+                   true, NO_CACHE);
+
+    }
+    }
+  return changed_p;
+}
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 /* Structure to pass dimensions around.  Used for character bounding
    boxes, glyph matrix dimensions and alike.  */
 
@@ -3282,10 +3744,36 @@ redraw_overlapped_rows (struct window *w, int yb)
 	    {
 	      output_cursor_to (w, i, 0, row->y,
 				area == TEXT_AREA ? row->x : 0);
-	      if (row->used[area])
+
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  if ((w->mc_elts.used > 0 || w->ch_elts.used > 0 || w->fc_elts.used > 0)
+      && area == TEXT_AREA
+      && row->used[area])
+    {
+      struct glyph_matrix *matrix = w->current_matrix;
+      int start_x = row->x;
+      int start_hpos = 0;
+      int end_hpos = row->used[area];
+      bool clear_eol_p = true;
+      enum draw_glyphs_face hl = DRAW_NORMAL_TEXT;
+      TRACE ((stderr, "redraw_overlapped_rows (%d):  start_x (%d) | start_hpos (%d) | end_hpos (%d)\n",
+                      i, start_x, start_hpos, end_hpos));
+      mc_redraw_row (w, matrix, row, start_x, start_hpos, end_hpos, clear_eol_p, hl);
+    }
+    else if (row->used[area])
+      {
 		FRAME_RIF (f)->write_glyphs (w, row, row->glyphs[area],
                                              area, row->used[area]);
 	      FRAME_RIF (f)->clear_end_of_line (w, row, area, -1);
+      }
+
+/* *************************************************************************** */
+
+
 	    }
 
 	  row->overlapped_p = 0;
@@ -3388,6 +3876,28 @@ static bool
 update_window (struct window *w, bool force_p)
 {
   struct glyph_matrix *desired_matrix = w->desired_matrix;
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+  if (trace_redisplay_p)
+    fprintf (stderr, "update_window (%s)\n", mc_window (w));
+
+  cursor_matrix = NULL;
+
+  struct frame *f = XFRAME (w->frame);
+  bool active_p = (w == XWINDOW (f->selected_window)
+                   && f == FRAME_DISPLAY_INFO (f)->x_highlight_frame);
+
+  mc_set_essentials (w, active_p, &ch_foreground, &fc_foreground, &fc_x);
+
+  mc_pre_scroll_clean (w);
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
   bool paused_p;
   int preempt_count = clip_to_bounds (1, baud_rate / 2400 + 1, INT_MAX);
   struct redisplay_interface *rif = FRAME_RIF (XFRAME (WINDOW_FRAME (w)));
@@ -3460,6 +3970,41 @@ update_window (struct window *w, bool force_p)
 	    }
 	}
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  /* Process the cursor row at the outset if it is within `desired_matrix`.
+  When processing all other rows, we will query the `w->current_matrix` for data
+  relating to the cursor row.  `make_current` (within `update_window_line')
+  updates the `w->current_matrix` for the applicable row.  In doing so, however,
+  the applicable row in the desired matrix is altered such that we can no longer
+  rely upon the accuracy of `ROW->used[TEXT_AREA]`.  Therefore, we must now rely
+  exclusively upon `w->current_matrix' for cursor row based decisions. */
+  for (struct glyph_row *mc_row = row;
+       mc_row < end && (force_p || !input_pending);
+       ++mc_row)
+    {
+      int vpos = MATRIX_ROW_VPOS (mc_row, desired_matrix);
+      if (mc_row->enabled_p
+          && vpos == w->cursor.vpos)
+        {
+          cursor_matrix = desired_matrix;
+          if (!force_p && ++n_updated % preempt_count == 0)
+            detect_input_pending_ignore_squeezables ();
+          changed_p |= update_window_line (w, vpos, &mouse_face_overwritten_p);
+          if (MATRIX_ROW_BOTTOM_Y (row) >= yb)
+            for (int i = vpos + 1; i < w->current_matrix->nrows - 1; ++i)
+              SET_MATRIX_ROW_ENABLED_P (w->current_matrix, i, false);
+          break;
+        }
+    }
+
+  cursor_matrix = w->current_matrix;
+
+/* *************************************************************************** */
+
+
       /* Update the rest of the lines.  */
       for (; row < end && (force_p || !input_pending); ++row)
 	/* scrolling_window resets the enabled_p flag of the rows it
@@ -3467,6 +4012,19 @@ update_window (struct window *w, bool force_p)
 	if (row->enabled_p)
 	  {
 	    int vpos = MATRIX_ROW_VPOS (row, desired_matrix);
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  /* If the `cursor_row` is within the `desired_matrix`, then it was proceed
+  hereinabove and should be skipped at this time. */
+  if (vpos == w->cursor.vpos)
+    continue;
+
+/* *************************************************************************** */
+
+
 	    int i;
 
 	    /* We'll have to play a little bit with when to
@@ -3497,6 +4055,43 @@ update_window (struct window *w, bool force_p)
 
     set_cursor:
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  /* If we jumped here from `set_cursor`, then set the `cursor_matrix`. */
+  if (cursor_matrix == NULL)
+    cursor_matrix = w->current_matrix;
+
+  /* Reset `row` to 0 so that fake cursors can be drawn on rows preceding the
+  first `row->enabled_p`.  Just prior to the call to `scrolling_window' above,
+  `row` was advanced to the first `row->enabled_p`. */
+  for (struct glyph_row *desired_row = MATRIX_ROW (desired_matrix, 0);
+       desired_row < end
+       && (force_p || !input_pending)
+       /* W32 Emacs crashes on startup without a BUFFERP check. */
+       && BUFFERP (w->contents)
+       && (!NILP (BVAR (XBUFFER (w->contents), mc_conf))
+           || !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+           || !NILP (BVAR (XBUFFER (w->contents), fc_visible)));
+       ++desired_row)
+   {
+     int vpos = MATRIX_ROW_VPOS (desired_row, desired_matrix);
+     if (desired_row->enabled_p)
+       continue;
+     struct glyph_row *bottom_row = MATRIX_BOTTOM_TEXT_ROW (w->current_matrix, w);
+     int bottom_vpos = MATRIX_ROW_VPOS (bottom_row, w->current_matrix);
+     struct glyph_row *current_row = MATRIX_ROW (w->current_matrix, vpos);
+     if (current_row->enabled_p)
+       mc_draw_row (w, w->current_matrix, current_row, current_row->glyphs[TEXT_AREA],
+                    current_row->x, current_row->used[TEXT_AREA], vpos,
+                    bottom_vpos, active_p, cursor_matrix, fc_x, ch_foreground,
+                    fc_foreground, true);
+   }
+
+/* *************************************************************************** */
+
+
       /* Update the header line after scrolling because a new header
 	 line would otherwise overwrite lines at the top of the window
 	 that can be scrolled.  */
@@ -3531,10 +4126,21 @@ update_window (struct window *w, bool force_p)
       strcpy (w->current_matrix->method, w->desired_matrix->method);
 #endif
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
 #ifdef HAVE_WINDOW_SYSTEM
+  if (BUFFERP (w->contents)
+      && !NILP (BVAR (XBUFFER (w->contents), crosshairs)))
+    mc_update_window_fringes (w, 0);
+    else
       update_window_fringes (w, 0);
 #endif
 
+/* *************************************************************************** */
+
+
       /* End the update of window W.  Don't set the cursor if we
          paused updating the display because in this case,
          set_window_cursor_after_update hasn't been called, and
@@ -3852,14 +4458,28 @@ update_window_line (struct window *w, int vpos, bool *mouse_face_overwritten_p)
 	  current_row->redraw_fringe_bitmaps_p = 1;
 	}
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  bool updated_p = (BUFFERP (w->contents)
+                    && (!NILP (BVAR (XBUFFER (w->contents), mc_conf))
+                        || !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+                        || ! NILP (BVAR (XBUFFER (w->contents), fc_visible))))
+                   ? mc_update_text_area (w, desired_row, vpos)
+                   : update_text_area (w, desired_row, vpos);
+
       /* Update the display of the text area.  */
-      if (update_text_area (w, desired_row, vpos))
+      if (updated_p)
 	{
 	  changed_p = 1;
 	  if (current_row->mouse_face_p)
 	    *mouse_face_overwritten_p = 1;
 	}
 
+/* *************************************************************************** */
+
+
       /* Update display of the right margin area, if there is one.  */
       if (!desired_row->full_width_p && w->right_margin_cols > 0)
 	{
diff --git a/src/frame.h b/src/frame.h
index ec8f614..eeaf71e 100644
--- a/src/frame.h
+++ b/src/frame.h
@@ -205,6 +205,16 @@ struct frame
   Lisp_Object tool_bar_items;
   /* tool_bar_items should be the last Lisp_Object member.  */
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  /* Non-nil when the frame is in the process of being updated. */
+  struct frame *mc_updating_frame;
+
+/* *************************************************************************** */
+
+
   /* Cache of realized faces.  */
   struct face_cache *face_cache;
 
